#include <windows.h>
#include "config.h"

SettingsInfo localInfo;

// Dialog Procedure
BOOL CALLBACK configDlgProc(HWND hwnd,UINT msg,WPARAM wp,LPARAM lp) {
	lp;
	WORD id=LOWORD(wp);
	switch(msg) {
		case WM_INITDIALOG:
			CheckDlgButton(hwnd,RES2CTRL,BST_CHECKED);
			CheckDlgButton(hwnd,BPP1CTRL,BST_CHECKED);
			CheckDlgButton(hwnd,FULLCTRL,BST_CHECKED);
			CheckDlgButton(hwnd,SYNCCTRL,BST_CHECKED);
			localInfo.wscr=800;
			localInfo.hscr=600;
			localInfo.bpp=16;
			localInfo.vsync=true;
			localInfo.full=true;
			return TRUE;
		case WM_COMMAND:
			switch(id) {
				case BUT1CTRL:
					if (IsDlgButtonChecked(hwnd,RES1CTRL)==BST_CHECKED) {
						localInfo.wscr=640;
						localInfo.hscr=480;
					}
					if (IsDlgButtonChecked(hwnd,RES2CTRL)==BST_CHECKED) {
						localInfo.wscr=800;
						localInfo.hscr=600;
					}
					if (IsDlgButtonChecked(hwnd,RES3CTRL)==BST_CHECKED) {
						localInfo.wscr=1024;
						localInfo.hscr=768;
					}
					if (IsDlgButtonChecked(hwnd,BPP1CTRL)==BST_CHECKED) localInfo.bpp=16;
					if (IsDlgButtonChecked(hwnd,BPP2CTRL)==BST_CHECKED) localInfo.bpp=24;
					if (IsDlgButtonChecked(hwnd,BPP3CTRL)==BST_CHECKED) localInfo.bpp=32;
					if (IsDlgButtonChecked(hwnd,FULLCTRL)==BST_CHECKED) localInfo.full=true;
					else localInfo.full=false;
          		if (IsDlgButtonChecked(hwnd,SYNCCTRL)==BST_CHECKED) localInfo.vsync=true;
          		else localInfo.vsync=false;
					EndDialog(hwnd,0);
					return TRUE;
				case BUT2CTRL:
					EndDialog(hwnd,-1);
					return TRUE;
				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
}

bool displayConfigDialog(HINSTANCE hInstance,SettingsInfo &si) {
	int result=DialogBoxParam(hInstance,MAKEINTRESOURCE(DIALOGID),NULL,(DLGPROC)configDlgProc,(LPARAM)0);
	si=localInfo;
	if (result==-1) return false;
	else return true;
}
