// *****************************
// ***    T e x t u r e s    ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Caricamento di file bmp e
// uso come texture

#ifndef TEXTURESH
#define TEXTURESH

#include "common.h"
#include "image.h"

#define NORMAL	0
#define BUMP1	1
#define BUMP2	2

#define DETAIL0	0
#define DETAIL1	1
#define DETAIL2	2

class Texture {
	GLuint name;
	bool ready;
public:
	Texture();
	~Texture();
	bool setDiffuseMap(char*,int);
	bool setBumpMap(char*,int,int);
	void apply();
	void kill();
};

struct texFile {
	char fname[50];
	GLuint bind;
	int num;
	int detail;
	int tp;
	texFile *next;
};

class TexManager {
	texFile *allTex;
public:
	TexManager();
	~TexManager();
	GLuint bind(char*,int,int);
	void kill(GLuint);
};

#endif
