// *****************************
// ***  B a c k g r o u n d  ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Oggetti per creare vari tipi
// di sfondo

#include "common.h"
#include "materials.h"

#define STARFIELD	0

// *****************************
// ***  B a c k g r o u n d  ***
// *****************************

class Background {
protected:
public:
	Background();
	virtual ~Background();
	virtual void kill() = 0;
	virtual void render() = 0;
	virtual int id() = 0;
};

// *****************************
// ***   S t a r f i e l d   ***
// *****************************

class Starfield:public Background {
	GLuint list1;
	GLuint list2;
	Texture map;
	bool ready1;
	bool ready2;
public:
	Starfield();
	~Starfield();
	void create(float,float,int,char*,float);
	void kill();
	void render();
	int id();
};

