// *****************************
// ***      C a m e r a      ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Realizzazione di una telecamera
// con 6 gradi di libert

#include "camera.h"

Camera::Camera() {
	//smooth(0.4);
}

Camera Camera::getView(int v) {
	Camera cam=*this;
	switch (v) {
		case FRONT:
			break;
		case BACK:
			cam.heading(180.0);
			break;
		case LEFT:
			cam.heading(90.0);
			break;
		case RIGHT:
			cam.heading(-90.0);
			break;
		case UP:
			cam.pitch(-90.0);
			break;
		case DOWN:
			cam.pitch(90.0);
			break;
	}
	return cam;
}

void Camera::apply() {
	xyzSystem::apply();
	Vector v1=getEyePoint();
	Vector v2=add(getEyePoint(),getViewDir());
	Vector v3=getUpVector();
	gluLookAt(v1.x,v1.y,v1.z,v2.x,v2.y,v2.z,v3.x,v3.y,v3.z);
}

void Camera::applyRot() {
	Vector v2=getViewDir();
	Vector v3=getUpVector();
	gluLookAt(0.0,0.0,0.0,v2.x,v2.y,v2.z,v3.x,v3.y,v3.z);
}

