// *****************************
// ***     M e s s a g e     ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Sistema di messaggi per debug
// e informare l'utente

#include "message.h"

FILE *bugfile;
int ind=0;
char *text=0;

void box(char *s) {
	MessageBox(NULL,s,"Message",MB_OK|MB_ICONINFORMATION);
}

void openMsg() {
	bugfile=fopen("debug.log","wb");
	text=new char[3000];
}

void closeMsg() {
	fclose(bugfile);
	delete[] text;
}

void prnTabs() {
	for(int i=0;i<ind;i++)
		fputs("  ",bugfile);
}

void message(const char *fmt, ...) {
	va_list ap;
	if (fmt==NULL) return;
	va_start(ap,fmt);
	vsprintf(text,fmt,ap);
	va_end(ap);
	prnTabs();
	fputs(text,bugfile);
	return;
}

void flush() {
	fflush(bugfile);
}

void indent() {
	ind++;
}

void deindent() {
	ind--;
	if (ind<0) ind=0;
}